Index: nick.c
===================================================================
--- nick.c	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ nick.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,6 +1,6 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2012 Wilmer van der Gaast and others                *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
   \********************************************************************/
 
@@ -20,6 +20,6 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
@@ -27,403 +27,237 @@
 #include "bitlbee.h"
 
+void nick_set( irc_t *irc, char *handle, int proto, char *nick )
+{
+	nick_t *m = NULL, *n = irc->nicks;
+	
+	while( n )
+	{
+		if( ( g_strcasecmp( n->handle, handle ) == 0 ) && n->proto == proto )
+		{
+			g_free( n->nick );
+			n->nick = nick_dup( nick );
+			nick_strip( n->nick );
+			
+			return;
+		}
+		n = ( m = n )->next;	// :-P
+	}
+	
+	if( m )
+		n = m->next = g_new0( nick_t, 1 );
+	else
+		n = irc->nicks = g_new0( nick_t, 1 );
+	
+	n->handle = g_strdup( handle );
+	n->proto = proto;
+	n->nick = nick_dup( nick );
+	
+	nick_strip( n->nick );
+}
+
+char *nick_get( irc_t *irc, char *handle, int proto, const char *realname )
+{
+	static char nick[MAX_NICK_LENGTH+1];
+	nick_t *n = irc->nicks;
+	int inf_protection = 256;
+	
+	memset( nick, 0, MAX_NICK_LENGTH + 1 );
+	
+	while( n && !*nick )
+		if( ( n->proto == proto ) && ( g_strcasecmp( n->handle, handle ) == 0 ) )
+			strcpy( nick, n->nick );
+		else
+			n = n->next;
+	
+	if( !n )
+	{
+		char *s;
+		
+		g_snprintf( nick, MAX_NICK_LENGTH, "%s", handle );
+		if( ( s = strchr( nick, '@' ) ) )
+			while( *s )
+				*(s++) = 0;
+		
+		/* All-digit handles (mainly ICQ UINs) aren't cool, try to
+		   use the realname instead. */
+		for( s = nick; *s && isdigit( *s ); s ++ );
+		if( !*s && realname && *realname )
+			g_snprintf( nick, MAX_NICK_LENGTH, "%s", realname );
+		
+		nick_strip( nick );
+		if (set_getint(irc, "lcnicks")) 
+			nick_lc( nick );
+	}
+	
+	while( !nick_ok( nick ) || user_find( irc, nick ) )
+	{
+		if( strlen( nick ) < ( MAX_NICK_LENGTH - 1 ) )
+		{
+			nick[strlen(nick)+1] = 0;
+			nick[strlen(nick)] = '_';
+		}
+		else
+		{
+			nick[0] ++;
+		}
+		
+		if( inf_protection-- == 0 )
+		{
+			int i;
+			
+			irc_usermsg( irc, "WARNING: Almost had an infinite loop in nick_get()! "
+			                  "This used to be a fatal BitlBee bug, but we tried to fix it. "
+			                  "This message should *never* appear anymore. "
+			                  "If it does, please *do* send us a bug report! "
+			                  "Please send all the following lines in your report:" );
+			
+			irc_usermsg( irc, "Trying to get a sane nick for handle %s", handle );
+			for( i = 0; i < MAX_NICK_LENGTH; i ++ )
+				irc_usermsg( irc, "Char %d: %c/%d", i, nick[i], nick[i] );
+			
+			irc_usermsg( irc, "FAILED. Returning an insane nick now. Things might break. "
+			                  "Good luck, and please don't forget to paste the lines up here "
+			                  "in #bitlbee on OFTC or in a mail to wilmer@gaast.net" );
+			
+			g_snprintf( nick, MAX_NICK_LENGTH + 1, "xx%x", rand() );
+			
+			break;
+		}
+	}
+	
+	return( nick );
+}
+
+void nick_del( irc_t *irc, char *nick )
+{
+	nick_t *l = NULL, *n = irc->nicks;
+	
+	while( n )
+	{
+		if( g_strcasecmp( n->nick, nick ) == 0 )
+		{
+			if( l )
+				l->next = n->next;
+			else
+				irc->nicks = n->next;
+			
+			g_free( n->handle );
+			g_free( n->nick );
+			g_free( n );
+			
+			break;
+		}
+		n = (l=n)->next;
+	}
+}
+
+
 /* Character maps, _lc_[x] == _uc_[x] (but uppercase), according to the RFC's.
-   With one difference, we allow dashes. These are used to do uc/lc conversions
-   and strip invalid chars. */
-static char *nick_lc_chars = "0123456789abcdefghijklmnopqrstuvwxyz{}^`-_|";
-static char *nick_uc_chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ[]~`-_\\";
-
-/* Store handles in lower case and strip spaces, because AIM is braindead. */
-static char *clean_handle(const char *orig)
-{
-	char *new = g_malloc(strlen(orig) + 1);
-	int i = 0;
-
-	do {
-		if (*orig != ' ') {
-			new[i++] = g_ascii_tolower(*orig);
-		}
-	} while (*(orig++));
-
-	return new;
-}
-
-void nick_set_raw(account_t *acc, const char *handle, const char *nick)
-{
-	char *store_handle, *store_nick = g_malloc(MAX_NICK_LENGTH + 1);
-	irc_t *irc = (irc_t *) acc->bee->ui_data;
-
-	store_handle = clean_handle(handle);
-	store_nick[MAX_NICK_LENGTH] = '\0';
-	strncpy(store_nick, nick, MAX_NICK_LENGTH);
-	nick_strip(irc, store_nick);
-
-	g_hash_table_replace(acc->nicks, store_handle, store_nick);
-}
-
-void nick_set(bee_user_t *bu, const char *nick)
-{
-	nick_set_raw(bu->ic->acc, bu->handle, nick);
-}
-
-char *nick_get(bee_user_t *bu)
-{
-	static char nick[MAX_NICK_LENGTH + 1];
-	char *store_handle, *found_nick;
-	irc_t *irc = (irc_t *) bu->bee->ui_data;
-
-	memset(nick, 0, MAX_NICK_LENGTH + 1);
-
-	store_handle = clean_handle(bu->handle);
-	/* Find out if we stored a nick for this person already. If not, try
-	   to generate a sane nick automatically. */
-	if ((found_nick = g_hash_table_lookup(bu->ic->acc->nicks, store_handle))) {
-		strncpy(nick, found_nick, MAX_NICK_LENGTH);
-	} else if ((found_nick = nick_gen(bu))) {
-		strncpy(nick, found_nick, MAX_NICK_LENGTH);
-		g_free(found_nick);
-	} else {
-		/* Keep this fallback since nick_gen() can return NULL in some cases. */
-		char *s;
-
-		g_snprintf(nick, MAX_NICK_LENGTH, "%s", bu->handle);
-		if ((s = strchr(nick, '@'))) {
-			while (*s) {
-				*(s++) = 0;
-			}
-		}
-
-		nick_strip(irc, nick);
-		if (set_getbool(&bu->bee->set, "nick_lowercase")) {
-			nick_lc(irc, nick);
-		}
-	}
-	g_free(store_handle);
-
-	/* Make sure the nick doesn't collide with an existing one by adding
-	   underscores and that kind of stuff, if necessary. */
-	nick_dedupe(bu, nick);
-
-	return nick;
-}
-
-char *nick_gen(bee_user_t *bu)
-{
-	gboolean ok = FALSE; /* Set to true once the nick contains something unique. */
-	GString *ret = g_string_sized_new(MAX_NICK_LENGTH + 1);
-	char *rets;
-	irc_t *irc = (irc_t *) bu->bee->ui_data;
-	char *fmt = set_getstr(&bu->ic->acc->set, "nick_format") ? :
-	            set_getstr(&bu->bee->set, "nick_format");
-
-	while (fmt && *fmt && ret->len < MAX_NICK_LENGTH) {
-		char *part = NULL, chop = '\0', *asc = NULL, *s;
-		int len = INT_MAX;
-
-		if (*fmt != '%') {
-			g_string_append_c(ret, *fmt);
-			fmt++;
-			continue;
-		}
-
-		fmt++;
-		while (*fmt) {
-			/* -char means chop off everything from char */
-			if (*fmt == '-') {
-				chop = fmt[1];
-				if (chop == '\0') {
-					g_string_free(ret, TRUE);
-					return NULL;
-				}
-				fmt += 2;
-			} else if (g_ascii_isdigit(*fmt)) {
-				len = 0;
-				/* Grab a number. */
-				while (g_ascii_isdigit(*fmt)) {
-					len = len * 10 + (*(fmt++) - '0');
-				}
-			} else if (g_strncasecmp(fmt, "nick", 4) == 0) {
-				part = bu->nick ? : bu->handle;
-				fmt += 4;
-				ok |= TRUE;
-				break;
-			} else if (g_strncasecmp(fmt, "handle", 6) == 0) {
-				part = bu->handle;
-				fmt += 6;
-				ok |= TRUE;
-				break;
-			} else if (g_strncasecmp(fmt, "full_name", 9) == 0) {
-				part = bu->fullname;
-				fmt += 9;
-				ok |= part && *part;
-				break;
-			} else if (g_strncasecmp(fmt, "first_name", 10) == 0) {
-				part = bu->fullname;
-				fmt += 10;
-				ok |= part && *part;
-				chop = ' ';
-				break;
-			} else if (g_strncasecmp(fmt, "group", 5) == 0) {
-				part = bu->group ? bu->group->name : NULL;
-				fmt += 5;
-				break;
-			} else if (g_strncasecmp(fmt, "account", 7) == 0) {
-				part = bu->ic->acc->tag;
-				fmt += 7;
-				break;
-			} else {
-				g_string_free(ret, TRUE);
-				return NULL;
-			}
-		}
-
-		if (!part) {
-			continue;
-		}
-
-		/* Credits to Josay_ in #bitlbee for this idea. //TRANSLIT
-		   should do lossy/approximate conversions, so letters with
-		   accents don't just get stripped. Note that it depends on
-		   LC_CTYPE being set to something other than C/POSIX. */
-		if (!(irc && irc->status & IRC_UTF8_NICKS)) {
-			asc = g_convert_with_fallback(part, -1, "ASCII//TRANSLIT", "UTF-8", "", NULL, NULL, NULL);
-
-			if (!asc) {
-				/* If above failed, try again without //TRANSLIT.
-				   //TRANSLIT is a GNU iconv special and is not POSIX.
-				   Other platforms may not support it. */
-				asc = g_convert_with_fallback(part, -1, "ASCII", "UTF-8", "", NULL, NULL, NULL);
-			}
-
-			part = asc;
-		}
-
-		if (part && chop && (s = strchr(part, chop))) {
-			len = MIN(len, s - part);
-		}
-
-		if (part) {
-			if (len < INT_MAX) {
-				g_string_append_len(ret, part, len);
-			} else {
-				g_string_append(ret, part);
-			}
-		}
-		g_free(asc);
-	}
-
-	rets = g_string_free(ret, FALSE);
-	if (ok && rets && *rets) {
-		nick_strip(irc, rets);
-
-		if (set_getbool(&bu->bee->set, "nick_lowercase")) {
-			nick_lc(irc, rets);
-		}
-
-		truncate_utf8(rets, MAX_NICK_LENGTH);
-		return rets;
-	}
-	g_free(rets);
-	return NULL;
-}
-
-/* Used for nicks and channel names too! */
-void underscore_dedupe(char nick[MAX_NICK_LENGTH + 1])
-{
-	if (strlen(nick) < (MAX_NICK_LENGTH - 1)) {
-		nick[strlen(nick) + 1] = 0;
-		nick[strlen(nick)] = '_';
-	} else {
-		/* We've got no more space for underscores,
-		   so truncate it and replace the last three
-		   chars with a random "_XX" suffix */
-		int len = truncate_utf8(nick, MAX_NICK_LENGTH - 3);
-		nick[len] = '_';
-		g_snprintf(nick + len + 1, 3, "%2x", rand());
-	}
-}
-
-void nick_dedupe(bee_user_t *bu, char nick[MAX_NICK_LENGTH + 1])
-{
-	irc_t *irc = (irc_t *) bu->bee->ui_data;
-	int inf_protection = 256;
-	irc_user_t *iu;
-
-	/* Now, find out if the nick is already in use at the moment, and make
-	   subtle changes to make it unique. */
-	while (!nick_ok(irc, nick) ||
-	       ((iu = irc_user_by_name(irc, nick)) && iu->bu != bu)) {
-
-		underscore_dedupe(nick);
-
-		if (inf_protection-- == 0) {
-			g_snprintf(nick, MAX_NICK_LENGTH + 1, "xx%x", rand());
-
-			irc_rootmsg(irc, "Warning: Something went wrong while trying "
-			            "to generate a nickname for contact %s on %s.",
-			            bu->handle, bu->ic->acc->tag);
-			irc_rootmsg(irc, "This might be a bug in BitlBee, or the result "
-			            "of a faulty nick_format setting. Will use %s "
-			            "instead.", nick);
-
-			break;
-		}
-	}
-}
-
-/* Just check if there is a nickname set for this buddy or if we'd have to
-   generate one. */
-int nick_saved(bee_user_t *bu)
-{
-	char *store_handle, *found;
-
-	store_handle = clean_handle(bu->handle);
-	found = g_hash_table_lookup(bu->ic->acc->nicks, store_handle);
-	g_free(store_handle);
-
-	return found != NULL;
-}
-
-void nick_del(bee_user_t *bu)
-{
-	g_hash_table_remove(bu->ic->acc->nicks, bu->handle);
-}
-
-
-void nick_strip(irc_t *irc, char *nick)
-{
-	int len = 0;
-	gboolean nick_underscores = irc ? set_getbool(&irc->b->set, "nick_underscores") : FALSE;
-
-	if (irc && (irc->status & IRC_UTF8_NICKS)) {
-		gunichar c;
-		char *p = nick, *n, tmp[strlen(nick) + 1];
-
-		while (p && *p) {
-			c = g_utf8_get_char_validated(p, -1);
-			n = g_utf8_find_next_char(p, NULL);
-
-			if (nick_underscores && c == ' ') {
-				*p = '_';
-				p = n;
-			} else if ((c < 0x7f && !(strchr(nick_lc_chars, c) ||
-			                          strchr(nick_uc_chars, c))) ||
-			    !g_unichar_isgraph(c)) {
-				strcpy(tmp, n);
-				strcpy(p, tmp);
-			} else {
-				p = n;
-			}
-		}
-		if (p) {
-			len = p - nick;
-		}
-	} else {
-		int i;
-
-		for (i = len = 0; nick[i] && len < MAX_NICK_LENGTH; i++) {
-			if (nick_underscores && nick[i] == ' ') {
-				nick[len] = '_';
-				len++;
-			} else if (strchr(nick_lc_chars, nick[i]) ||
-			    strchr(nick_uc_chars, nick[i])) {
-				nick[len] = nick[i];
-				len++;
-			}
-		}
-	}
-	if (g_ascii_isdigit(nick[0])) {
-		char *orig;
-
-		/* First character of a nick can't be a digit, so insert an
-		   underscore if necessary. */
-		orig = g_strdup(nick);
-		g_snprintf(nick, MAX_NICK_LENGTH, "_%s", orig);
-		g_free(orig);
-		len++;
-	}
-	while (len <= MAX_NICK_LENGTH) {
-		nick[len++] = '\0';
-	}
-}
-
-gboolean nick_ok(irc_t *irc, const char *nick)
-{
-	const char *s;
-
-	/* Empty/long nicks are not allowed, nor numbers at [0] */
-	if (!*nick || g_ascii_isdigit(nick[0]) || strlen(nick) > MAX_NICK_LENGTH) {
-		return 0;
-	}
-
-	if (irc && (irc->status & IRC_UTF8_NICKS)) {
-		gunichar c;
-		const char *p = nick, *n;
-
-		while (p && *p) {
-			c = g_utf8_get_char_validated(p, -1);
-			n = g_utf8_find_next_char(p, NULL);
-
-			if ((c < 0x7f && !(strchr(nick_lc_chars, c) ||
-			                   strchr(nick_uc_chars, c))) ||
-			    !g_unichar_isgraph(c)) {
-				return FALSE;
-			}
-			p = n;
-		}
-	} else {
-		for (s = nick; *s; s++) {
-			if (!strchr(nick_lc_chars, *s) && !strchr(nick_uc_chars, *s)) {
-				return FALSE;
-			}
-		}
-	}
-
-	return TRUE;
-}
-
-int nick_lc(irc_t *irc, char *nick)
+   With one difference, we allow dashes. */
+
+static char *nick_lc_chars = "0123456789abcdefghijklmnopqrstuvwxyz{}^-_|";
+static char *nick_uc_chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ[]~-_\\";
+
+void nick_strip( char * nick )
+{
+	int i, j;
+	
+	for( i = j = 0; nick[i] && i < MAX_NICK_LENGTH; i++ )
+	{
+		if( strchr( nick_lc_chars, nick[i] ) || 
+		    strchr( nick_uc_chars, nick[i] ) )
+		{
+			nick[j] = nick[i];
+			j++;
+		}
+	}
+	while( j < MAX_NICK_LENGTH )
+		nick[j++] = '\0';
+}
+
+int nick_ok( char *nick )
+{
+	char *s;
+	
+	/* Empty/long nicks are not allowed */
+	if( !*nick || strlen( nick ) > MAX_NICK_LENGTH )
+		return( 0 );
+	
+	for( s = nick; *s; s ++ )
+		if( !strchr( nick_lc_chars, *s ) && !strchr( nick_uc_chars, *s ) )
+			return( 0 );
+	
+	return( 1 );
+}
+
+int nick_lc( char *nick )
+{
+	static char tab[256] = { 0 };
+	int i;
+	
+	if( tab['A'] == 0 )
+		for( i = 0; nick_lc_chars[i]; i ++ )
+		{
+			tab[(int)nick_uc_chars[i]] = nick_lc_chars[i];
+			tab[(int)nick_lc_chars[i]] = nick_lc_chars[i];
+		}
+	
+	for( i = 0; nick[i]; i ++ )
+	{
+		if( !tab[(int)nick[i]] )
+			return( 0 );
+		
+		nick[i] = tab[(int)nick[i]];
+	}
+	
+	return( 1 );
+}
+
+int nick_uc( char *nick )
 {
 	static char tab[128] = { 0 };
 	int i;
-
-	if (tab['A'] == 0) {
-		/* initialize table so nonchars are mapped to themselves */
-		for (i = 0; i < sizeof(tab); i++) {
-			tab[i] = i;
-		}
-		/* replace uppercase chars with lowercase chars */
-		for (i = 0; nick_lc_chars[i]; i++) {
-			tab[(int) nick_uc_chars[i]] = nick_lc_chars[i];
-		}
-	}
-
-	if (irc && (irc->status & IRC_UTF8_NICKS)) {
-		gchar *down = g_utf8_strdown(nick, -1);
-		if (strlen(down) > strlen(nick)) {
-			truncate_utf8(down, strlen(nick));
-		}
-		strcpy(nick, down);
-		g_free(down);
-	}
-
-	for (i = 0; nick[i]; i++) {
-		if (((guchar) nick[i]) < 0x7f) {
-			nick[i] = tab[(guchar) nick[i]];
-		}
-	}
-
-	return nick_ok(irc, nick);
-}
-
-int nick_cmp(irc_t *irc, const char *a, const char *b)
+	
+	if( tab['A'] == 0 )
+		for( i = 0; nick_lc_chars[i]; i ++ )
+		{
+			tab[(int)nick_uc_chars[i]] = nick_uc_chars[i];
+			tab[(int)nick_lc_chars[i]] = nick_uc_chars[i];
+		}
+	
+	for( i = 0; nick[i]; i ++ )
+	{
+		if( !tab[(int)nick[i]] )
+			return( 0 );
+		
+		nick[i] = tab[(int)nick[i]];
+	}
+	
+	return( 1 );
+}
+
+int nick_cmp( char *a, char *b )
 {
 	char aa[1024] = "", bb[1024] = "";
-
-	strncpy(aa, a, sizeof(aa) - 1);
-	strncpy(bb, b, sizeof(bb) - 1);
-	if (nick_lc(irc, aa) && nick_lc(irc, bb)) {
-		return(strcmp(aa, bb));
-	} else {
-		return(-1);     /* Hmm... Not a clear answer.. :-/ */
-	}
-}
+	
+	strncpy( aa, a, sizeof( aa ) - 1 );
+	strncpy( bb, b, sizeof( bb ) - 1 );
+	if( nick_lc( aa ) && nick_lc( bb ) )
+	{
+		return( strcmp( aa, bb ) );
+	}
+	else
+	{
+		return( -1 );	/* Hmm... Not a clear answer.. :-/ */
+	}
+}
+
+char *nick_dup( char *nick )
+{
+	char *cp;
+	
+	cp = g_new0 ( char, MAX_NICK_LENGTH + 1 );
+	strncpy( cp, nick, MAX_NICK_LENGTH );
+	
+	return( cp );
+}
Index: nick.h
===================================================================
--- nick.h	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ nick.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,3 +1,3 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
@@ -20,21 +20,24 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
-void nick_set_raw(account_t *acc, const char *handle, const char *nick);
-void nick_set(bee_user_t *bu, const char *nick);
-char *nick_get(bee_user_t *bu);
-char *nick_gen(bee_user_t *bu);
-void underscore_dedupe(char nick[MAX_NICK_LENGTH + 1]);
-void nick_dedupe(bee_user_t * bu, char nick[MAX_NICK_LENGTH + 1]);
-int nick_saved(bee_user_t *bu);
-void nick_del(bee_user_t *bu);
+typedef struct __NICK
+{
+	char *handle;
+	int proto;
+	char *nick;
+	struct __NICK *next;
+} nick_t;
 
-void nick_strip(irc_t *irc, char *nick);
-gboolean nick_ok(irc_t *irc, const char *nick);
-int nick_lc(irc_t *irc, char *nick);
-int nick_uc(irc_t *irc, char *nick);
-int nick_cmp(irc_t *irc, const char *a, const char *b);
-char *nick_dup(const char *nick);
+void nick_set( irc_t *irc, char *handle, int proto, char *nick );
+char *nick_get( irc_t *irc, char *handle, int proto, const char *realname );
+void nick_del( irc_t *irc, char *nick );
+void nick_strip( char *nick );
+
+int nick_ok( char *nick );
+int nick_lc( char *nick );
+int nick_uc( char *nick );
+int nick_cmp( char *a, char *b );
+char *nick_dup( char *nick );
Index: protocols/Makefile
===================================================================
--- protocols/Makefile	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ protocols/Makefile	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -8,11 +8,7 @@
 
 -include ../Makefile.settings
-ifdef _SRCDIR_
-_SRCDIR_ := $(_SRCDIR_)protocols/
-endif
 
 # [SH] Program variables
-objects = account.o bee.o bee_chat.o bee_ft.o bee_user.o nogaim.o
-
+objects = md5.o nogaim.o proxy.o sha.o util.o $(SSL_CLIENT)
 
 # [SH] The next two lines should contain the directory name (in $(subdirs))
@@ -25,12 +21,9 @@
 # Expansion of variables
 subdirobjs := $(join $(subdirs),$(addprefix /,$(subdirobjs)))
+CFLAGS += -Wall
 LFLAGS += -r
 
 # [SH] Phony targets
 all: protocols.o
-check: all
-lcov: check
-gcov:
-	gcov *.c
 
 .PHONY: all clean distclean $(subdirs)
@@ -40,8 +33,7 @@
 
 distclean: clean $(subdirs)
-	rm -rf .depend
 
 $(subdirs):
-	$(MAKE) -C $@ $(MAKECMDGOALS)
+	@$(MAKE) -C $@ $(MAKECMDGOALS)
 
 ### MAIN PROGRAM
@@ -49,11 +41,9 @@
 protocols.o: $(objects) $(subdirs)
 	@echo '*' Linking protocols.o
-	$(VERBOSE) $(LD) $(LFLAGS) $(objects) $(subdirobjs) -o protocols.o
+	@$(LD) $(LFLAGS) $(objects) $(subdirobjs) -o protocols.o
 
 $(objects): ../Makefile.settings Makefile
 
-$(objects): %.o: $(_SRCDIR_)%.c
+$(objects): %.o: %.c
 	@echo '*' Compiling $<
-	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
-
--include .depend/*.d
+	@$(CC) -c $(CFLAGS) $< -o $@
Index: protocols/jabber/Makefile
===================================================================
--- protocols/jabber/Makefile	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ protocols/jabber/Makefile	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -8,19 +8,13 @@
 
 -include ../../Makefile.settings
-ifdef _SRCDIR_
-_SRCDIR_ := $(_SRCDIR_)protocols/jabber/
-endif
 
 # [SH] Program variables
-objects = conference.o io.o iq.o jabber.o jabber_util.o message.o presence.o s5bytestream.o sasl.o si.o hipchat.o
+objects = expat.o hashtable.o jid.o jpacket.o jutil.o log.o pool.o str.o xmlnode.o xmlparse.o xmlrole.o xmltok.o jabber.o
 
+CFLAGS += -Wall
 LFLAGS += -r
 
 # [SH] Phony targets
-all: jabber_mod.o
-check: all
-lcov: check
-gcov: 
-	gcov *.c
+all: jabberr.o
 
 .PHONY: all clean distclean
@@ -30,5 +24,4 @@
 
 distclean: clean
-	rm -rf .depend
 
 ### MAIN PROGRAM
@@ -36,11 +29,9 @@
 $(objects): ../../Makefile.settings Makefile
 
-$(objects): %.o: $(_SRCDIR_)%.c
+$(objects): %.o: %.c
 	@echo '*' Compiling $<
-	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	@$(CC) -c $(CFLAGS) $< -o $@
 
-jabber_mod.o: $(objects)
-	@echo '*' Linking jabber_mod.o
-	$(VERBOSE) $(LD) $(LFLAGS) $(objects) -o jabber_mod.o
-
--include .depend/*.d
+jabberr.o: $(objects)
+	@echo '*' Linking jabberr.o
+	@$(LD) $(LFLAGS) $(objects) -o jabberr.o
Index: protocols/jabber/asciitab.h
===================================================================
--- protocols/jabber/asciitab.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ protocols/jabber/asciitab.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,62 @@
+/*
+The contents of this file are subject to the Mozilla Public License
+Version 1.1 (the "License"); you may not use this file except in
+compliance with the License. You may obtain a copy of the License at
+http://www.mozilla.org/MPL/
+
+Software distributed under the License is distributed on an "AS IS"
+basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
+License for the specific language governing rights and limitations
+under the License.
+
+The Original Code is expat.
+
+The Initial Developer of the Original Code is James Clark.
+Portions created by James Clark are Copyright (C) 1998, 1999
+James Clark. All Rights Reserved.
+
+Contributor(s):
+
+Alternatively, the contents of this file may be used under the terms
+of the GNU General Public License (the "GPL"), in which case the
+provisions of the GPL are applicable instead of those above.  If you
+wish to allow use of your version of this file only under the terms of
+the GPL and not to allow others to use your version of this file under
+the MPL, indicate your decision by deleting the provisions above and
+replace them with the notice and other provisions required by the
+GPL. If you do not delete the provisions above, a recipient may use
+your version of this file under either the MPL or the GPL.
+*/
+
+/* 0x00 */ BT_NONXML, BT_NONXML, BT_NONXML, BT_NONXML,
+/* 0x04 */ BT_NONXML, BT_NONXML, BT_NONXML, BT_NONXML,
+/* 0x08 */ BT_NONXML, BT_S, BT_LF, BT_NONXML,
+/* 0x0C */ BT_NONXML, BT_CR, BT_NONXML, BT_NONXML,
+/* 0x10 */ BT_NONXML, BT_NONXML, BT_NONXML, BT_NONXML,
+/* 0x14 */ BT_NONXML, BT_NONXML, BT_NONXML, BT_NONXML,
+/* 0x18 */ BT_NONXML, BT_NONXML, BT_NONXML, BT_NONXML,
+/* 0x1C */ BT_NONXML, BT_NONXML, BT_NONXML, BT_NONXML,
+/* 0x20 */ BT_S, BT_EXCL, BT_QUOT, BT_NUM,
+/* 0x24 */ BT_OTHER, BT_PERCNT, BT_AMP, BT_APOS,
+/* 0x28 */ BT_LPAR, BT_RPAR, BT_AST, BT_PLUS,
+/* 0x2C */ BT_COMMA, BT_MINUS, BT_NAME, BT_SOL,
+/* 0x30 */ BT_DIGIT, BT_DIGIT, BT_DIGIT, BT_DIGIT,
+/* 0x34 */ BT_DIGIT, BT_DIGIT, BT_DIGIT, BT_DIGIT,
+/* 0x38 */ BT_DIGIT, BT_DIGIT, BT_COLON, BT_SEMI,
+/* 0x3C */ BT_LT, BT_EQUALS, BT_GT, BT_QUEST,
+/* 0x40 */ BT_OTHER, BT_HEX, BT_HEX, BT_HEX,
+/* 0x44 */ BT_HEX, BT_HEX, BT_HEX, BT_NMSTRT,
+/* 0x48 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
+/* 0x4C */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
+/* 0x50 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
+/* 0x54 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
+/* 0x58 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_LSQB,
+/* 0x5C */ BT_OTHER, BT_RSQB, BT_OTHER, BT_NMSTRT,
+/* 0x60 */ BT_OTHER, BT_HEX, BT_HEX, BT_HEX,
+/* 0x64 */ BT_HEX, BT_HEX, BT_HEX, BT_NMSTRT,
+/* 0x68 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
+/* 0x6C */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
+/* 0x70 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
+/* 0x74 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
+/* 0x78 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_OTHER,
+/* 0x7C */ BT_VERBAR, BT_OTHER, BT_OTHER, BT_OTHER,
Index: protocols/jabber/expat.c
===================================================================
--- protocols/jabber/expat.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ protocols/jabber/expat.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,54 @@
+/* --------------------------------------------------------------------------
+ *
+ * License
+ *
+ * The contents of this file are subject to the Jabber Open Source License
+ * Version 1.0 (the "JOSL").  You may not copy or use this file, in either
+ * source code or executable form, except in compliance with the JOSL. You
+ * may obtain a copy of the JOSL at http://www.jabber.org/ or at
+ * http://www.opensource.org/.  
+ *
+ * Software distributed under the JOSL is distributed on an "AS IS" basis,
+ * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the JOSL
+ * for the specific language governing rights and limitations under the
+ * JOSL.
+ *
+ * Copyrights
+ * 
+ * Portions created by or assigned to Jabber.com, Inc. are 
+ * Copyright (c) 1999-2002 Jabber.com, Inc.  All Rights Reserved.  Contact
+ * information for Jabber.com, Inc. is available at http://www.jabber.com/.
+ *
+ * Portions Copyright (c) 1998-1999 Jeremie Miller.
+ * 
+ * Acknowledgements
+ * 
+ * Special thanks to the Jabber Open Source Contributors for their
+ * suggestions and support of Jabber.
+ * 
+ * Alternatively, the contents of this file may be used under the terms of the
+ * GNU General Public License Version 2 or later (the "GPL"), in which case
+ * the provisions of the GPL are applicable instead of those above.  If you
+ * wish to allow use of your version of this file only under the terms of the
+ * GPL and not to allow others to use your version of this file under the JOSL,
+ * indicate your decision by deleting the provisions above and replace them
+ * with the notice and other provisions required by the GPL.  If you do not
+ * delete the provisions above, a recipient may use your version of this file
+ * under either the JOSL or the GPL. 
+ * 
+ * 
+ * --------------------------------------------------------------------------*/
+
+#include "lib.h"
+#include <glib.h>
+
+void xmlnode_put_expat_attribs(xmlnode owner, const char** atts)
+{
+    int i = 0;
+    if (atts == NULL) return;
+    while (atts[i] != '\0')
+    {
+        xmlnode_put_attrib(owner, atts[i], atts[i+1]);
+        i += 2;
+    }
+}
Index: protocols/jabber/hashtable.c
===================================================================
--- protocols/jabber/hashtable.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ protocols/jabber/hashtable.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,142 @@
+/*
+The contents of this file are subject to the Mozilla Public License
+Version 1.1 (the "License"); you may not use this file except in
+csompliance with the License. You may obtain a copy of the License at
+http://www.mozilla.org/MPL/
+
+Software distributed under the License is distributed on an "AS IS"
+basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
+License for the specific language governing rights and limitations
+under the License.
+
+The Original Code is expat.
+
+The Initial Developer of the Original Code is James Clark.
+Portions created by James Clark are Copyright (C) 1998, 1999
+James Clark. All Rights Reserved.
+
+Contributor(s):
+
+*/
+
+#include "xmldef.h"
+
+#ifdef XML_UNICODE_WCHAR_T
+#ifndef XML_UNICODE
+#define XML_UNICODE
+#endif
+#endif
+
+#include "hashtable.h"
+
+#define INIT_SIZE 64
+
+static
+int keyeq(KEY s1, KEY s2)
+{
+    for (; *s1 == *s2; s1++, s2++)
+        if (*s1 == 0)
+            return 1;
+    return 0;
+}
+
+static
+unsigned long hash(KEY s)
+{
+    unsigned long h = 0;
+    while (*s)
+        h = (h << 5) + h + (unsigned char)*s++;
+    return h;
+}
+
+NAMED *lookup(HASH_TABLE *table, KEY name, size_t createSize)
+{
+    size_t i;
+    if (table->size == 0) {
+        if (!createSize)
+            return 0;
+        table->v = calloc(INIT_SIZE, sizeof(NAMED *));
+        if (!table->v)
+            return 0;
+        table->size = INIT_SIZE;
+        table->usedLim = INIT_SIZE / 2;
+        i = hash(name) & (table->size - 1);
+    }
+    else {
+        unsigned long h = hash(name);
+        for (i = h & (table->size - 1);
+                table->v[i];
+                i == 0 ? i = table->size - 1 : --i) {
+            if (keyeq(name, table->v[i]->name))
+                return table->v[i];
+        }
+        if (!createSize)
+            return 0;
+        if (table->used == table->usedLim) {
+            /* check for overflow */
+            size_t newSize = table->size * 2;
+            NAMED **newV = calloc(newSize, sizeof(NAMED *));
+            if (!newV)
+                return 0;
+            for (i = 0; i < table->size; i++)
+                if (table->v[i]) {
+                    size_t j;
+                    for (j = hash(table->v[i]->name) & (newSize - 1);
+                            newV[j];
+                            j == 0 ? j = newSize - 1 : --j)
+                        ;
+                    newV[j] = table->v[i];
+                }
+            g_free(table->v);
+            table->v = newV;
+            table->size = newSize;
+            table->usedLim = newSize/2;
+            for (i = h & (table->size - 1);
+                    table->v[i];
+                    i == 0 ? i = table->size - 1 : --i)
+                ;
+        }
+    }
+    table->v[i] = calloc(1, createSize);
+    if (!table->v[i])
+        return 0;
+    table->v[i]->name = name;
+    (table->used)++;
+    return table->v[i];
+}
+
+void hashTableDestroy(HASH_TABLE *table)
+{
+    size_t i;
+    for (i = 0; i < table->size; i++) {
+        NAMED *p = table->v[i];
+        if (p)
+            g_free(p);
+    }
+    g_free(table->v);
+}
+
+void hashTableInit(HASH_TABLE *p)
+{
+    p->size = 0;
+    p->usedLim = 0;
+    p->used = 0;
+    p->v = 0;
+}
+
+void hashTableIterInit(HASH_TABLE_ITER *iter, const HASH_TABLE *table)
+{
+    iter->p = table->v;
+    iter->end = iter->p + table->size;
+}
+
+NAMED *hashTableIterNext(HASH_TABLE_ITER *iter)
+{
+    while (iter->p != iter->end) {
+        NAMED *tem = *(iter->p)++;
+        if (tem)
+            return tem;
+    }
+    return 0;
+}
+
